<template>
    <div class="flex items-center justify-between mb-4">
        <Breadcrumb nameRouteHome="admin" textRouteHome="Tổng quan">
            <ItemBreadcrumb>Quản lý lớp học</ItemBreadcrumb>
        </Breadcrumb>
        <BasicButton @click="showModal">
            <PlusCircleIcon class="text-white" />
            <span>Thêm mới</span>
        </BasicButton>
    </div>

    <div class="card">
        <div class="card-header border-b-none">
            <form
                @submit.prevent="submitSearchForm"
                class="flex items-end gap-3"
            >
                <div class="form-control">
                    <div>Từ khóa:</div>
                    <label for="keyword">
                        <input
                            v-model="keyword"
                            id="keyword"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                            placeholder="Họ tên hoặc email..."
                            autocomplete="off"
                        />
                    </label>
                </div>
                <BasicButton
                    type="submit"
                    classCustom="bg-color-warning hover:shadow-hover-warning"
                >
                    <SearchIcon class="text-white" />
                    <span>Tìm kiếm</span>
                </BasicButton>
            </form>
        </div>
        <table>
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Lớp học</th>
                    <th class="text-center">Giáo viên quản lý</th>
                    <th class="text-center">Tổng số học sinh</th>
                    <th>Thời gian tạo</th>
                    <th class="text-center">Hành động</th>
                </tr>
            </thead>
            <tbody>
                <template v-if="!isLoading">
                    <template v-if="classesComputed && classesComputed.length">
                        <tr
                            :key="itemClass.id"
                            v-for="(itemClass, index) in classesComputed"
                        >
                            <td>{{ index + 1 }}</td>
                            <td>{{ itemClass.name }}</td>
                            <td class="text-center">
                                <router-link
                                    :to="{
                                        name: 'admin-user-view',
                                        params: {
                                            userId: itemClass?.teacher.id
                                        }
                                    }"
                                    class="text-main-color"
                                >
                                    {{ itemClass?.teacher.name }}
                                </router-link>
                            </td>
                            <td class="text-center">
                                {{ itemClass.total_student }}
                            </td>
                            <td>{{ itemClass.created_at }}</td>
                            <td>
                                <div
                                    class="box-actions flex items-center justify-center gap-1"
                                >
                                    <router-link
                                        :to="{
                                            name: 'admin-class-view',
                                            params: { classId: itemClass.id }
                                        }"
                                        v-tooltip="'Xem'"
                                        class="action-view"
                                    >
                                        <EyeIcon />
                                    </router-link>
                                    <div
                                        @click="showModal(itemClass)"
                                        v-tooltip="'Sửa'"
                                        class="cursor-pointer action-edit"
                                    >
                                        <PencilIcon />
                                    </div>
                                    <div
                                        @click="onDelete(itemClass.id)"
                                        v-tooltip="'Xóa'"
                                        class="cursor-pointer action-delete"
                                    >
                                        <TrashIcon />
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </template>
                    <template v-else>
                        <tr class="no-data-table">
                            <td colspan="6" class="text-center">
                                Không có dữ liệu
                            </td>
                        </tr>
                    </template>
                </template>
                <template v-else>
                    <tr>
                        <td colspan="6" class="text-center">
                            <SpinLoading />
                        </td>
                    </tr>
                </template>
            </tbody>
        </table>
        <div
            v-if="!isLoading && classesComputed && classesComputed.length"
            class="flex justify-end p-6"
        >
            <BasicPagination
                @onClickPage="onClickPage"
                :currentPage="currentPage"
                :lastPage="lastPage"
            />
        </div>
    </div>

    <teleport to="body">
        <Modal v-model:isActiveModal="isActiveModal">
            <template v-slot:header><h4>Thêm lớp học</h4></template>
            <template v-slot:body>
                <div class="space-y-4">
                    <div class="form-control">
                        <label class="flex flex-col" for="name">
                            <div>
                                Tên lớp học <span class="text-red-500">*</span>
                            </div>
                            <input
                                v-model="className"
                                id="name"
                                type="text"
                                class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                                :class="{ 'border-red-400': errorClassName }"
                            />
                        </label>
                        <div
                            v-if="errorClassName"
                            class="text-left text-sm text-red-500 mt-1"
                        >
                            {{ errorClassName }}
                        </div>
                    </div>
                    <div class="form-control">
                        <label class="flex flex-col" for="teacher">
                            <div>
                                Giáo viên <span class="text-red-500">*</span>
                            </div>
                            <select
                                v-model="teacherId"
                                id="teacher"
                                class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                                :class="{
                                    'border-red-400': errorTeacherId
                                }"
                            >
                                <option disabled value="">
                                    Chọn giáo viên quản lý
                                </option>
                                <option
                                    :key="teacher.id"
                                    v-for="teacher in listUserWithPermission"
                                    :value="teacher.id"
                                >
                                    {{ teacher.name }}
                                </option>
                            </select>
                        </label>
                        <div
                            v-if="errorTeacherId"
                            class="text-left text-sm text-red-500 mt-1"
                        >
                            {{ errorTeacherId }}
                        </div>
                    </div>
                </div>
            </template>
            <template v-slot:btnSave>
                <BasicButton
                    @click="onSubmit"
                    type="submit"
                    classCustom="flex item-center gap-2 bg-color-primary hover:shadow-hover-primary"
                >
                    <SpinLoading
                        v-if="isLoadingCreateClass || isLoadingUpdateClass"
                        color="#ffffff"
                        size="15"
                    />
                    <span>Lưu</span>
                </BasicButton>
            </template>
        </Modal>
    </teleport>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import timeHelper from "@/helper/timeHelper";
import { ROLE_TEACHER } from "@/constants";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";

import useFetchAllClass from "@/hooks/class/useFetchAllClass";
import useDeleteClass from "@/hooks/class/useDeleteClass";
import useFetchAllUserPermission from "@/hooks/user/useFetchAllUserPermission";
import useCreateClass from "@/hooks/class/useCreateClass";
import useUpdateClass from "@/hooks/class/useUpdateClass";

import {
    PlusCircleIcon,
    SearchIcon,
    EyeIcon,
    PencilIcon,
    TrashIcon
} from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import Breadcrumb from "@/components/breadcrumb/Breadcrumb.vue";
import ItemBreadcrumb from "@/components/breadcrumb/ItemBreadcrumb.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";
import Modal from "@/components/modal/Modal.vue";

export default {
    components: {
        PlusCircleIcon,
        SearchIcon,
        EyeIcon,
        PencilIcon,
        TrashIcon,
        SpinLoading,
        Breadcrumb,
        ItemBreadcrumb,
        BasicButton,
        BasicPagination,
        Modal
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const classes = ref([]);
        const { isLoading, listClass, onFetchAllClass } = useFetchAllClass();
        const { errorResponse, onDeleteClass } = useDeleteClass();
        const {
            listUserWithPermission,
            onFetchAllUserPermission
        } = useFetchAllUserPermission();
        const {
            isLoadingCreateClass,
            newClass,
            onCreateClass
        } = useCreateClass();
        const {
            isLoadingUpdateClass,
            classUpdated,
            onUpdateClass
        } = useUpdateClass();

        async function onFetch() {
            await onFetchAllClass(route.query);
            classes.value = listClass.value.data;

            await onFetchAllUserPermission(ROLE_TEACHER);
        }
        onFetch();

        const classesComputed = computed(() => {
            if (classes.value && classes.value.length) {
                return classes.value.map(item => {
                    return {
                        ...item,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(item.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        const keyword = ref(route.query.keyword || null);
        async function submitSearchForm() {
            await onFetchAllClass({ keyword: keyword.value });
            classes.value = listClass.value.data;

            const path = route.path;

            let query = {};
            if (keyword.value) query = { ...query, keyword: keyword.value };

            router.push({ path, query });
        }

        // update currentPge and lastPage when change listClass
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listClass, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value }
            });

            await onFetchAllClass({ ...route.query, page: value });
            classes.value = listClass.value.data;
        }

        async function onDelete(id) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa lớp học này không?</span>`,
                confirmButtonText: "Xóa",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteClass(id);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponse.value) {
                        createToast("Xóa thất bại, đã có lỗi xảy ra", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        classes.value = classes.value.filter(user => {
                            return user.id != id;
                        });
                        createToast("Xóa thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        // modal
        const isActiveModal = ref(false);
        const classId = ref("");
        const className = ref("");
        const teacherId = ref("");
        const errorClassName = ref(null);
        const errorTeacherId = ref(null);
        function showModal(data = false) {
            isActiveModal.value = true;
            classId.value = "";
            className.value = "";
            teacherId.value = "";
            if (data) {
                classId.value = data.id;
                className.value = data.name;
                teacherId.value = data.teacher?.id;
            }
            errorClassName.value = null;
            errorTeacherId.value = null;
        }
        async function onSubmit() {
            errorClassName.value = null;
            errorTeacherId.value = null;

            let input_valid = true;
            if (!className.value || teacherId.value === "") {
                input_valid = false;
                if (!className.value)
                    errorClassName.value = "Bạn chưa nhập tên lớp học";
                if (teacherId.value === "")
                    errorTeacherId.value = "Bạn chưa chọn giáo viên quản lý";
            }

            if (input_valid) {
                if (classId.value) {
                    await onUpdateClass(
                        classId.value,
                        className.value,
                        teacherId.value
                    );
                    if (classUpdated.value) {
                        classes.value = classes.value.map(item => {
                            return item.id === classId.value
                                ? classUpdated.value
                                : item;
                        });
                    }
                    isActiveModal.value = false;
                    createToast("Cập nhật lớp học thành công", {
                        showIcon: true,
                        type: "success"
                    });
                } else {
                    await onCreateClass(className.value, teacherId.value);
                    if (newClass.value) {
                        classes.value = [newClass.value, ...classes.value];
                    }
                    isActiveModal.value = false;
                    createToast("Tạo lớp học thành công", {
                        showIcon: true,
                        type: "success"
                    });
                }
            }
        }

        return {
            isLoading,
            classesComputed,
            listUserWithPermission,
            isLoadingCreateClass,
            isLoadingUpdateClass,
            keyword,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage,
            onDelete,
            isActiveModal,
            className,
            errorClassName,
            teacherId,
            errorTeacherId,
            showModal,
            onSubmit
        };
    }
};
</script>
